#pragma once
#include "rpmostree-rust-prelude.h"
G_BEGIN_DECLS


/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

/**
 * Context object used to iterate through `HistoryEntry` events.
 */
typedef struct RORHistoryCtx RORHistoryCtx;

typedef struct RORTreefile RORTreefile;

/**
 * A history entry in the journal. It may represent multiple consecutive boots
 * into the same deployment. This struct is exposed directly via FFI to C.
 */
typedef struct RORHistoryEntry {
  /**
   * The deployment root timestamp.
   */
  uint64_t deploy_timestamp;
  /**
   * The command-line that was used to create the deployment, if any.
   */
  char *deploy_cmdline;
  /**
   * The number of consecutive times the deployment was booted.
   */
  uint64_t boot_count;
  /**
   * The first time the deployment was booted if multiple consecutive times.
   */
  uint64_t first_boot_timestamp;
  /**
   * The last time the deployment was booted if multiple consecutive times.
   */
  uint64_t last_boot_timestamp;
  /**
   * `true` if there are no more entries.
   */
  bool eof;
} RORHistoryEntry;

struct RORHistoryCtx *ror_history_ctx_new(RORGError **gerror);

int ror_history_ctx_next(struct RORHistoryCtx *hist,
                         struct RORHistoryEntry *entry,
                         RORGError **gerror);

void ror_history_ctx_free(struct RORHistoryCtx *hist);

void ror_history_entry_clear(struct RORHistoryEntry *entry);

int ror_history_prune(RORGError **gerror);

RORGHashTable *ror_lockfile_read(char **filenames, RORGError **gerror);

int ror_lockfile_write(const char *filename,
                       RORGPtrArray *packages,
                       RORGPtrArray *rpmmd_repos,
                       RORGError **gerror);

struct RORTreefile *ror_treefile_new(const char *filename,
                                     const char *basearch,
                                     int workdir_dfd,
                                     RORGError **gerror);

int ror_treefile_get_dfd(struct RORTreefile *tf);

int ror_treefile_get_postprocess_script_fd(struct RORTreefile *tf);

int ror_treefile_get_add_file_fd(struct RORTreefile *tf, const char *filename);

int ror_treefile_get_passwd_fd(struct RORTreefile *tf);

int ror_treefile_get_group_fd(struct RORTreefile *tf);

const char *ror_treefile_get_json_string(struct RORTreefile *tf);

char **ror_treefile_get_ostree_layers(struct RORTreefile *tf);

char **ror_treefile_get_ostree_override_layers(struct RORTreefile *tf);

char **ror_treefile_get_all_ostree_layers(struct RORTreefile *tf);

const char *ror_treefile_get_rojig_spec_path(struct RORTreefile *tf);

const char *ror_treefile_get_rojig_name(struct RORTreefile *tf);

char *ror_treefile_get_checksum(struct RORTreefile *tf, ROROstreeRepo *repo, RORGError **gerror);

bool ror_treefile_get_cliwrap(struct RORTreefile *tf);

bool ror_treefile_get_readonly_executables(struct RORTreefile *tf);

char *ror_treefile_get_rpmdb(struct RORTreefile *tf);

void ror_treefile_print_deprecation_warnings(struct RORTreefile *tf);

void ror_treefile_free(struct RORTreefile *tf);

char **ror_treefile_get_files_remove_regex(struct RORTreefile *tf, const char *package);

G_DEFINE_AUTOPTR_CLEANUP_FUNC(RORTreefile, ror_treefile_free)
G_DEFINE_AUTOPTR_CLEANUP_FUNC(RORHistoryCtx, ror_history_ctx_free)
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC(RORHistoryEntry, ror_history_entry_clear)
G_END_DECLS
